--***********************************************************************************************
-- Author : tobyatwork
-- Name   : Material Editor Manager
-- written: 2008-04-24
-- edited : 2008-04-28
-- Version: 1.0
-- 3dsmax : tested on v9 (x86/x64)
--***********************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK
--
--
macroScript MatEditingManager
category:"tobyatwork_scripts"
buttonText:"Material Editor Manager"
toolTip:"Modify Material Editor Materials"
(
	rollout MatEditingManagerWindow "Material Editor Manager" width:600 height:350
	(
				checkbox resetmateditor "reset material editor" checked:false pos:[13,25]
				checkbox erasescenemats "erase all scene mats" checked:false pos:[13,45]
				checkbox delcurrobjmat "delete selected object material" checked:false pos:[13,65]
				checkbox delnonselobj "delete unselected object material" checked:false pos:[13,85]
				checkbox delunusedmats "delete unused mats from scene" checked:false pos:[13,105]
				radiobuttons defaultorvray labels:#("Default Material", "mental ray Material", "V-Ray Material", "FinalRender Material", "Brazil r/s Material", "Maxwell Material", "Fryrender Material") default:1 pos:[13,130] enabled:false
				button btn_execute "Execute" width:70 height:20 pos:[19,245]
				button btn_cancel "Cancel" width:70 height:20 pos:[110, 245]
				--switch materials
				pickbutton pickbtn_obj1 "Pick Object 01" width:160 height:20 pos:[210, 25]
				pickbutton pickbtn_obj2 "Pick Object 02" width:160 height:20 pos:[210, 55]
				button btn_switch "Switch It!" width:75 height:20 pos:[210,85]
				button btn_switch_clear "Clear Selection" width:75 height:20 pos:[295,85]
				--save objects material to .mat-file
				pickbutton pickbtn_obj2mat "Pick Object" width:160 height:20 pos:[210, 145]
				button btn_export_obj2mat "Export to..." width:75 height:20 pos:[210, 175]
				button btn_export_obj2mat_clear "Clear Selection" width:75 height:20 pos:[295,175]
				--save all scene materials to .mat-file
				button btn_export_scenemat "Export Materials to..." width:160 height:20 pos:[210, 240]
				--about label
				label aboutMEM "MEM v1.0 by toby" pos:[55,297] height:13 width:100
				hyperlink abouttobyatwork "tobyatwork" address:"http://www.tobyatwork.de" color:(color 255 153 51) hovercolor:(color 255 153 51) visitedcolor:(color 255 153 51) pos:[75,320] height:15 width:100
				label aboutcopyright " 2007" pos:[80,310] height:12 width:60
			groupBox managemats "Managing MaterialEditor" width:190 height:270 pos:[5,5]
			groupBox switchobjmats "Switch Materials" width:182 height:115 pos:[200,5]
			groupBox savemtlojb2mat "Save Objects' Material to .mat" width:182 height:85 pos:[200,125]
			groupBox savescenemtl2mat "Save Scene Materials to .mat" width:182 height:60 pos:[200,215]
			groupBox aboutmanagemats "About" width:190 height:60 pos:[5,280]



				on resetmateditor changed state do
				(
					defaultorvray.enabled = state
				)

				on btn_execute pressed do
				(
					if resetmateditor.checked == true  and defaultorvray.state == 1 then
					(
						matcount = meditMaterials.count
						for i = 1 to matcount do
						(
							matindex = i as string
							while matindex.count < 2 do (matindex = "0" + matindex)
							meditMaterials[i] = standard name: (matindex +" - Default Material")
						)
						resetmateditor.checked = false
						defaultorvray.enabled = false
					)
					
					if resetmateditor.checked == true and defaultorvray.state == 2 then
					(
						matcount = meditMaterials.count
						for i = 1 to matcount do
						(
							matindex = i as string
							while matindex.count < 2 do (matindex = "0" + matindex)
							meditMaterials[i] = mental_ray ()
							 meditMaterials[i].name = matindex +" - mental ray Material"
						)
						resetmateditor.checked = false
						defaultorvray.enabled = false
					)

					if resetmateditor.checked == true and defaultorvray.state == 3 then
					(
						matcount = meditMaterials.count
						for i = 1 to matcount do
						(
							matindex = i as string
							while matindex.count < 2 do (matindex = "0" + matindex)
							meditMaterials[i] = VRayMtl name: (matindex +" - VRay Material")
						)
						resetmateditor.checked = false
						defaultorvray.enabled = false
					)



					if erasescenemats.checked == true then
					(
						$*.material = undefined
						erasescenemats.checked = false
					)

					if delcurrobjmat.checked == true then
					(
						for obj in selection do
						(
							$.material = undefined
							delcurrobjmat.checked = false
						)
					)

					if delnonselobj.checked == true then
					(
						actionMan.executeAction 0 "40044"
						for obj in selection do
						(
							$.material = undefined
							delnonselobj.checked = false
						)
					)
					
				)

				on btn_cancel pressed do
				(
					destroyDialog MatEditingManagerWindow
				)
				
				on pickbtn_obj1 picked obj01 do
				(
					global base_obj01 = obj01
					pickbtn_obj1.text = obj01.name
				)
				on pickbtn_obj2 picked obj02 do
				(
					global base_obj02 = obj02
					pickbtn_obj2.text = obj02.name
				)
				on btn_switch pressed do
				(
					--if objarray != undefined then
					--(
						objarray = #(base_obj01, base_obj02)
						mtl_1 = objarray[1].material
						mtl_2 = objarray[2].material
						objarray[1].material = mtl_2
						objarray[2].material = mtl_1
					--)
					--else (
					--	messageBox "- You forgot to pick the 2 objects which materials should be switched. -\n\nPlease select the objects with the desired pick-buttons first." title:"Switch Materials Error"
					--)
				)
				on btn_switch_clear pressed do
				(
					pickbtn_obj1.text = "Pick Object 01"
					pickbtn_obj2.text = "Pick Object 02"
					base_obj01 = undefined
					base_obj02 = undefined
				)
				
				on pickbtn_obj2mat picked obj2mat do
				(
					global base_obj2mat = obj2mat
					pickbtn_obj2mat.text = obj2mat.name
				)
				
				on btn_export_obj2mat pressed do
				(
					loadDefaultMatLib()
					append currentMaterialLibrary base_obj2mat.material
					fileSaveAsMatLib()
					
				)
				on btn_export_obj2mat_clear pressed do
				(
					pickbtn_obj2mat.text = "Pick Object"
					base_obj2mat = undefined
				)
				
				on btn_export_scenemat pressed do
				(
					local exp_scenemat_array = #()
					exp_scenemat_array = for exp_scenemat_obj in $* where exp_scenemat_obj.material != undefined collect exp_scenemat_obj					
					loadDefaultMatLib()
					for i=1 to exp_scenemat_array.count do
					(
						append currentMaterialLibrary exp_scenemat_array[i].material
					)
					fileSaveAsMatLib()
					
				)



	)

	createDialog MatEditingManagerWindow width:600 height:350 style:#(#style_toolwindow, #style_border, #style_sysmenu)
)
